      SUBROUTINE  autoext(err,manual)
c
c...Guess Catalog First Guess
c
      INCLUDE
     *            'tbproc.inc'
      PARAMETER
     *            rtest = 90*1000*100
      INTEGER
     *            i, x1bar, y1bar, x2bar, y2bar, xmin, xmax, ymin, ymax,
     *            r, rmax, x1step, y1step, x2step, y2step, x1c, y1c,
     *            x2c, y2c, nx, ny, err, nin2, manual, n1min, nin1,
     *            mx, my
      REAL
     *            dx, dy, dr
      CHARACTER*1
     *            c
c
 9001 FORMAT (' NX=', i1, '   NY=', i1, '   N2P=', i4, ' To R=', i8,
     *        '  N1P=', i4, '  X=', i10, '  Y=', i10)
 9002 FORMAT (' Is This OK (Y/N): ' $)
 9003 FORMAT (a)
 9004 FORMAT (i2, 2(2x,1pe14.7))
c
c...Compute Mean From (1)
c
  100 IF (manual.eq.0) THEN
        n1min = 8
      ELSE
        n1min = 5
      ENDIF
      xmin = x1(1)
      xmax = x1(1)
      ymin = y1(1)
      ymax = y1(1)
      DO i=2,n1
        xmin = MIN(xmin,x1(i))
        xmax = MAX(xmax,x1(i))
        ymin = MIN(ymin,y1(i))
        ymax = MAX(ymax,y1(i))
      ENDDO
      x1bar = (xmax+xmin+1)/2
      y1bar = (ymin+ymax+1)/2
      x1step = (xmax-xmin)/10
      y1step = (ymax-ymin)/10
      zonex0 = x1bar/100
      zoney0 = y1bar/100
c
c...Compute Mean From (2)
c
      nin2 = 0
      DO i=1,n2
        IF (use2(i).ne.0) THEN
          nin2 = nin2+1
          IF (nin2.eq.1) THEN
            xmin = x2(1)
            xmax = x2(1)
            ymin = y2(1)
            ymax = y2(1)
          ELSE
            xmin = MIN(xmin,x2(i))
            xmax = MAX(xmax,x2(i))
            ymin = MIN(ymin,y2(i))
            ymax = MAX(ymax,y2(i))
          ENDIF
        ENDIF
      ENDDO
      x2bar = (xmin+xmax+1)/2
      y2bar = (ymin+ymax+1)/2
      x2step = (xmax-xmin)/10
      y2step = (ymax-ymin)/10
c
c...Override This
c
      x1bar = 17500000
      y1bar = 17500000
      x2bar = x2over
      y2bar = y2over
      x1step =        0
      y1step =        0
      x2step =  1000000
      y2step =  1000000
c
c...Coded As Double Loop So As To Try Several Places On The Plate
c
c	Note:  Swap so that nominal pointing goes first
c
 9991 DO mx=4,6
 9992   DO my=4,6
          IF ((mx.eq.4).and.(my.eq.4)) THEN
            nx = 5
            ny = 5
          ELSEIF ((mx.eq.5).and.(my.eq.5)) THEN
            nx = 4
            ny = 4
          ELSE
            nx = mx
            ny = my
          ENDIF
          y1c = y1bar + (ny-5)*y1step
          y2c = y2bar + (ny-5)*y2step
          x1c = x1bar + (nx-5)*x1step
          x2c = x2bar + (nx-5)*x2step
c
c...Find Brightest NEXTMAX Inside Of RTEST
c
          nin2 = 0
          DO i=1,n2
            IF (use2(i).ne.0) THEN
              IF  ((ABS(x2(i)-x2c).le.RTEST)
     *        .and.(ABS(y2(i)-y2c).le.RTEST)) THEN
                nin2 = nin2 + 1
                idx(nin2) = i
                tmp(nin2) = d2(i)
              ENDIF
            ENDIF
          ENDDO
          CALL iuqsrt(nin2,tmp,idx)
          n2p = MIN(NEXTMAX,200,nin2)
          DO i=1,n2p
            x2p(i) = x2(idx(i))
            y2p(i) = y2(idx(i))
            m2p(i) = d2(idx(i))
            i2p(i) = idx(i)
          ENDDO
c
c...Find Brightest NEXTMAX Inside Of RTEST
c
          nin1 = 0
          DO i=1,n1
            IF  ((ABS(x1(i)-x1c).le.RTEST)
     *      .and.(ABS(y1(i)-y1c).le.RTEST)) THEN
              nin1 = nin1+1
              idx(nin1) = i
              tmp(nin1) = d1(i)
            ENDIF
          ENDDO
          CALL iuqsrt(nin1,tmp,idx)
          n1p = MIN(NEXTMAX,200,nin1)
          DO i=1,n1p
            x1p(i) = x1(idx(i))
            y1p(i) = y1(idx(i))
            m1p(i) = d1(idx(i))
            i1p(i) = idx(i)
          ENDDO
          WRITE (*,9001) nx,ny,n2p,RTEST,n1p,x2c,y2c
c
c...If We Have Enough, Attempt To Guess Transformation
c
          IF (n1p.ge.n1min) THEN
            DO i=1,n1p
              idx(i) = i
            ENDDO
            CALL iuqsrt(n1p,x1p,idx)
            CALL ireord(n1p,idx,y1p,tmp)
            CALL ireord(n1p,idx,m1p,tmp)
            CALL ireord(n1p,idx,i1p,tmp)
            DO i=1,n2p
              idx(i) = i
            ENDDO
            CALL iuqsrt(n2p,x2p,idx)
            CALL ireord(n2p,idx,y2p,tmp)
            CALL ireord(n2p,idx,m2p,tmp)
            CALL ireord(n2p,idx,i2p,tmp)
            CALL dstguess(err)
            IF (manual.eq.0) THEN
              IF (err.eq.0) RETURN
            ELSE
              IF (err.eq.0) THEN
                DO i=1,3
                  WRITE (*,9004) i,xcoef(i),ycoef(i)
                ENDDO
  120           WRITE (*,9002)
                READ  (*,9003) c
                IF ((c.eq.'y').or.(c.eq.'Y')) THEN
                  RETURN
                ELSEIF ((c.eq.'n').or.(c.eq.'N')) THEN
                  CONTINUE
                ELSE
                  GO TO 120
                ENDIF
              ENDIF
            ENDIF
c
c...End Of Loops
c
          ENDIF
        ENDDO
      ENDDO
      err = 1
      RETURN
      END
