      SUBROUTINE  damper
c
c...Remove DEC/Mag correlation
c
      INCLUDE
     *            'parfit.inc'
      PARAMETER
     *            xmag = 18.0D00
      INTEGER
     *            id, i, j, nfn, nlb(NP1), ntb, nn, in(NP1), ndc
      CHARACTER*200
     *            fn, lb(NP1), tb
      DOUBLE PRECISION
     *            xx(NP1), yb(NP1), yr(NP1), ww(NP1), rr(NP1),
     *            bdc(NCMAX), sbdc(NCMAX), rdc(NCMAX), srdc(NCMAX)
c
 9001 FORMAT (q, a)
 9002 FORMAT (i4, 2i3, 30x, 10(1x,1pe11.4))
 9003 FORMAT (10(1x,1pe11.4))
 9004 FORMAT (a)
c
c...Read Old File
c
  100 IF (noop.eq.0) THEN
        fn = 'soucoef.'//cpass
        nfn = 8+LEN(cpass)
      ELSE
        fn = 'unsoucoef.'//cpass
        nfn = 10+LEN(cpass)
      ENDIF
      OPEN (
     *      access='sequential',
     *      carriagecontrol='list',
     *      dispose='keep',
     *      form='formatted',
     *      name=fn(1:nfn),
     *      readonly,
     *      shared,
     *      status='old',
     *      unit=8
     *     )
      nn = 0
  110 READ (8,9001,end=120) ntb,tb
      nn = nn+1
      lb(nn) = tb
      nlb(nn) = ntb
      READ (tb(1:ntb),9002) id,nbcoef,nrcoef,(bcoef(j),j=1,nbcoef),
     *                      (rcoef(j),j=1,nrcoef)
      xx(nn) = id
      IF (nbcoef.eq.1) THEN
        yb(nn) = bcoef(1)
      ELSE
        yb(nn) = bcoef(1) + XMAG*bcoef(2)
      ENDIF
      IF (nrcoef.eq.1) THEN
        yr(nn) = rcoef(1)
      ELSE
        yr(nn) = rcoef(1) + XMAG*rcoef(2)
      ENDIF
      ww(nn) = 1.0D00
      in(nn) = 1
      GO TO 110
  120 CLOSE (8)
c
c...Compute Correlation
c
      ndc = 2
      CALL pfit(nn,xx,yb,ww,rr,in, ndc,bdc,sbdc,bsig)
      DO j=1,nn
        yb(j) = rr(j)
      ENDDO
      CALL pfit(nn,xx,yr,ww,rr,in, ndc,rdc,srdc,rsig)
      DO j=1,nn
        yr(j) = rr(j)
      ENDDO
c
c...Scribble New Version Of The File
c
      OPEN (
     *      access='sequential',
     *      carriagecontrol='list',
     *      dispose='keep',
     *      form='formatted',
     *      name=fn(1:nfn),
     *      status='unknown',
     *      unit=8
     *     )
      DO i=1,nn
        tb = lb(i)
        ntb = nlb(i)
        READ (tb(1:ntb),9002) id,nbcoef,nrcoef,(bcoef(j),j=1,nbcoef),
     *                        (rcoef(j),j=1,nrcoef)
        IF (nbcoef.eq.1) THEN
          bcoef(1) = yb(i)
        ELSE
          bcoef(1) = yb(i)
        ENDIF
        IF (nrcoef.eq.1) THEN
          rcoef(1) = yr(i)
        ELSE
          rcoef(1) = yr(i)
        ENDIF
        WRITE (tb(41:ntb),9003) (bcoef(j),j=1,nbcoef),
     *                          (rcoef(j),j=1,nrcoef)
        WRITE (8,9004) tb(1:ntb)
      ENDDO
      CLOSE (8)
      WRITE (9,9003) (bdc(j),j=1,ndc),(rdc(j),j=1,ndc)
      RETURN
      END
