      SUBROUTINE  dofit1(err)
c
c...Least Squares Fit Of Some Kind
c
      INCLUDE
     *            'color1.inc'
      INTEGER
     *            i, j, k, ising, nin, nfree, err
      DOUBLE PRECISION
     *            chisq, y, yc, yr
c
c...Initialization
c
  100 DO i=1,nc
        cc(i) = 0.0D00
        zlhs(i) = 0.D00
        DO j=1,nc
          zrhs(i,j) = 0.0D00
        ENDDO
      ENDDO
      chisq = 0.0D00
      nin = 0
c
c...Accumulation
c
      DO i=1,mm
        IF (kk(i).ne.0) THEN
          CALL gimmedv(i,y)
          IF (y.ne.TAG) THEN
            DO j=1,nc
              zlhs(j) = zlhs(j) + dv(j)*y
              DO k=1,nc
                zrhs(j,k) = zrhs(j,k) + dv(j)*dv(k)
              ENDDO
            ENDDO
            nin = nin+1
          ENDIF
        ENDIF
      ENDDO
c
c...Inversion
c
      nfree = nin - (nc+1)
      IF (nfree.le.0) THEN
        err = -1
        RETURN
      ENDIF
      CALL inv1(ising)
      IF (ising.ne.0) THEN
        err = -2
        RETURN
      ENDIF
c
c...Coefficients
c
      DO i=1,nc
        DO j=1,nc
          cc(i) = cc(i) + zrhs(i,j)*zlhs(j)
        ENDDO
      ENDDO
c
c...Residuals And ChiSquared
c
      DO i=1,mm
        CALL gimmedv(i,y)
        IF (y.eq.TAG) THEN
          re(i) = TAG
        ELSE
          yc = 0.0D00
          DO j=1,nc
            yc = yc + dv(j)*cc(j)
          ENDDO
          yr = y-yc
          re(i) = yr
          IF (kk(i).ne.0) THEN
            chisq = chisq + yr*yr
          ENDIF
        ENDIF
      ENDDO
c
c...Errors
c
      sg = SQRT(chisq/nfree)
      DO i=1,nc
        ss(i) = sg*SQRT(zrhs(i,i))
      ENDDO
      err = 0
      RETURN
      END
