      SUBROUTINE  dostaff(id,hole,nn,xx,yy,err)
c
c...Load Taff-O-Gram And Remove It
c
      IMPLICIT
     *            NONE
      PARAMETER
     *            nzone = 8,
     *            ntdim = 65
      INTEGER
     *            id, err, zlast(NZONE), nlb, ntb, i, j, n, ix, iy,
     *            icx, icy, nn, xx(*), yy(*), hole
      DOUBLE PRECISION
     *            z0taff, dztaff, holex0(8), holey0(8), xmm, ymm,
     *            xtaff(NTDIM,NTDIM), ytaff(NTDIM,NTDIM), fx, fy,
     *            cx, cy, rx, ry
      CHARACTER*64
     *            lb, tb
      DATA
     *  zlast/110, 192, 292, 408, 537, 678, 822, 894/
c
 9001 FORMAT ('GSCTAFF:taff2', i1, '.hdr')
 9002 FORMAT (' Fatal STAFF Error For ID=', i3, '  >>', a, '<<')
 9003 FORMAT (i5, 2f10.0)
 9004 FORMAT (1x, 2f10.0)
 9005 FORMAT (' Loaded STaff-O-Gram For ID=', i3, ' From ', a)
c
c...Load Taff-O-Gram
c
  100 DO j=1,NZONE
        IF (id.le.zlast(j)) GO TO 110
      ENDDO
      err = -56
      RETURN
  110 WRITE (lb,9001) j
      nlb = 18
      CALL f_doenv(lb(1:nlb),ntb,tb)
      OPEN (
     *        access='sequential',
     *        carriagecontrol='list',
     *        dispose='keep',
     *        err=200,
     *        form='formatted',
     *        name=tb(1:ntb),
     *        readonly,
     *        shared,
     *        status='old',
     *        unit=1
     *       )
      READ (1,9003) n,z0taff,dztaff
      DO i=1,8
        READ (1,9004) holex0(i),holey0(i)
      ENDDO
      CLOSE (1)
      tb(ntb-2:ntb) = 'dat'
      OPEN (
     *      access='direct',
     *      carriagecontrol='none',
     *      convert='big_endian',
     *      dispose='keep',
     *      err=200,
     *      form='unformatted',
     *      name=tb(1:ntb),
     *      readonly,
     *      recl=(2*NTDIM*NTDIM),
     *      recordtype='fixed',
     *      shared,
     *      status='old',
     *      unit=1
     *     )
      READ (1,rec=1) xtaff
      READ (1,rec=2) ytaff
      CLOSE (1)
c
c...Apply The Correction
c
      DO i=1,nn
        xmm = 0.00001D00*xx(i) - holex0(hole)
        ymm = 0.00001D00*yy(i) - holey0(hole)
        ix = (xmm-z0taff)/dztaff + 1.0D00
        iy = (ymm-z0taff)/dztaff + 1.0D00
        fx = (xmm - (z0taff + (ix-1)*dztaff))/dztaff
        fy = (ymm - (z0taff + (iy-1)*dztaff))/dztaff
        rx = 1.0D00-fx
        ry = 1.0D00-fy
c
c...Cases Where IX Is Too Small
c
        IF (ix.lt.1) THEN
          IF (iy.lt.1) THEN
            cx = xtaff(    1,    1)
            cy = ytaff(    1,    1)
          ELSEIF (iy.ge.NTDIM) THEN
            cx = xtaff(    1,NTDIM)
            cy = ytaff(    1,NTDIM)
          ELSE
            cx = ry*xtaff(    1,iy) + fy*xtaff(    1,iy+1)
            cy = ry*ytaff(    1,iy) + fy*ytaff(    1,iy+1)
         ENDIF
c
c...Cases Where IX Is Too Large
c
        ELSEIF (ix.ge.NTDIM) THEN
          IF (iy.lt.1) THEN
            cx = xtaff(NTDIM,    1)
            cy = ytaff(NTDIM,    1)
          ELSEIF (iy.ge.NTDIM) THEN
            cx = xtaff(NTDIM,NTDIM)
            cy = ytaff(NTDIM,NTDIM)
          ELSE
            cx = ry*xtaff(NTDIM,iy) + fy*xtaff(NTDIM,iy+1)
            cy = ry*ytaff(NTDIM,iy) + fy*ytaff(NTDIM,iy+1)
          ENDIF
c
c...Cases Where IX Is Legal
c
        ELSE
          IF (iy.lt.1) THEN
            cx = rx*xtaff(ix,    1) + fx*xtaff(ix+1,    1)
            cy = rx*ytaff(ix,    1) + fx*ytaff(ix+1,    1)
          ELSEIF (iy.ge.NTDIM) THEN
            cx = rx*xtaff(ix,NTDIM) + fx*xtaff(ix+1,NTDIM)
            cy = rx*ytaff(ix,NTDIM) + fx*ytaff(ix+1,NTDIM)
          ELSE
            cx = rx*ry*xtaff(ix  ,iy  ) + fx*ry*xtaff(ix+1,iy  )
     *         + rx*fy*xtaff(ix  ,iy+1) + fx*fy*xtaff(ix+1,iy+1)
            cy = rx*ry*ytaff(ix  ,iy  ) + fx*ry*ytaff(ix+1,iy  )
     *         + rx*fy*ytaff(ix  ,iy+1) + fx*fy*ytaff(ix+1,iy+1)
          ENDIF
        ENDIF
        icx = -100.0D00*cx
        icy = -100.0D00*cy
        icx = MAX(-32768,MIN(32767,icx))
        icy = MAX(-32768,MIN(32767,icy))
        xx(i) = xx(i)+icx
        yy(i) = yy(i)+icy
      ENDDO
      err = 0
      RETURN
c
c...Some Kind Of Error
c
  200 err = -57
      RETURN
      END
