      SUBROUTINE  cuload(err)
c
c...Load And Transform UJ(J+F) Into System Oc CU
c
      INCLUDE
     *            'sdss.inc'
      INTEGER
     *            err, i, nlb, j, k, nn
      DOUBLE PRECISION
     *            x, y, xhat, yhat
      CHARACTER*64
     *            lb
      CHARACTER*11
     *            fn
      CHARACTER*4
     *            cz
c
 9001 FORMAT (i4.4)
 9002 FORMAT (i2, i10)
 9003 FORMAT (2x, 2(1x,e15.8))
 9004 FORMAT (3i10)
 9005 FORMAT (' Cannot Open ', a)
 9006 FORMAT (' Reading ', a)
c
c...Get FIT File
c
  100 WRITE (cz,9001) oldzone
      CALL f_doenv('AUXPAT:pat'//cz//'.sla',nlb,lb)
      CALL slaundump(lb(1:nlb),err)
      CALL f_doenv('AUXQU:qu'//cz//'.fit',nlb,lb)
      OPEN (
     *      access='sequential',
     *      carriagecontrol='list',
     *      dispose='keep',
     *      err=200,
     *      form='formatted',
     *      name=lb(1:nlb),
     *      readonly,
     *      shared,
     *      status='old',
     *      unit=1
     *     )
      READ (1,9002)
      READ (1,9002)
      READ (1,9002) ncucoef,ncupair
      DO i=1,ncucoef
        READ (1,9003) cuxcoef(i),cuycoef(i)
      ENDDO
      CLOSE (1)
c
c...Get PAR and DAT Files
c
      IF (IAND(verify,2).ne.0) THEN
        lb(nlb-2:nlb) = 'par'
        OPEN (
     *        access='direct',
     *        carriagecontrol='none',
     *        convert='big_endian',
     *        dispose='keep',
     *        err=200,
     *        form='unformatted',
     *        name=lb(1:nlb),
     *        readonly,
     *        recl=ncupair,
     *        recordtype='fixed',
     *        shared,
     *        status='old',
     *        unit=1
     *       )
        READ (1,rec=1) (bx(i),i=1,ncupair)
        READ (1,rec=2) (by(i),i=1,ncupair)
        CLOSE (1)
        CALL f_doenv('AUXPAT:pat'//cz//'.inf',nlb,lb)
        OPEN (
     *        access='sequential',
     *        carriagecontrol='list',
     *        dispose='keep',
     *        err=200,
     *        form='formatted',
     *        name=lb(1:nlb),
     *        readonly,
     *        shared,
     *        status='old',
     *        unit=1
     *       )
        READ (1,9004) nn
        CLOSE (1)
        lb(nlb-2:nlb) = 'dat'
        WRITE (*,9006) lb(1:nlb)
        OPEN (
     *        access='direct',
     *        carriagecontrol='none',
     *        convert='big_endian',
     *        dispose='keep',
     *        err=200,
     *        form='unformatted',
     *        name=lb(1:nlb),
     *        readonly,
     *        recl=nn,
     *        recordtype='fixed',
     *        shared,
     *        status='old',
     *        unit=1
     *       )
        READ (1,rec= 9) (x2(i),i=1,nn)
        READ (1,rec=10) (y2(i),i=1,nn)
        CLOSE (1)
      ENDIF
c
c...Transform Mean UJ(J+F)
c
      DO i=1,njfpair
        x = x1(i)/SCALE
        y = y1(i)/SCALE
        dv(1) = 1.0D00
        dv(2) = x
        dv(3) = y
        IF (ncucoef.gt.3) THEN
          dv(4) = x*x
          dv(5) = x*y
          dv(6) = y*y
          dv(7) = x*x*x
          dv(8) = x*x*y
          dv(9) = x*y*y
          dv(10) = y*y*y
        ENDIF
        xhat = 0.0D00
        yhat = 0.0D00
        DO j=1,ncucoef
          xhat = xhat + dv(j)*cuxcoef(j)
          yhat = yhat + dv(j)*cuycoef(j)
        ENDDO
        x1(i) = xhat*SCALE + 0.5D00
        y1(i) = yhat*SCALE + 0.5D00
      ENDDO
c
c...Final Check That All Is OK
c
      IF (IAND(verify,2).ne.0) THEN
        CALL cucheck(ncupair)
      ENDIF
      RETURN
c
c...You Better Not Get Here
c
  200 WRITE (*,9005) lb(1:nlb)
      err = -8
      RETURN
      END
