      SUBROUTINE  iterate(err)
c
c...Find Solution
c
      INCLUDE
     *            'sdss.inc'
      INTEGER
     *            err, i, niter, npold, j, k
c
 9001 FORMAT (' Guess  NP1=', i3, '  NP2=', i3, '  NPair=', i3)
 9002 FORMAT (' ITERATE Err=', i10)
 9003 FORMAT (' Niter=', i2, '  NPair=', i3, '  Sx=', f6.2,
     *        '  Sy=', f6.2, ' Arcsec')
 9004 FORMAT (i2, 2(3x, 1pe14.7, '+/-', 1pe10.3))
c
c...First Guess
c
  100 CALL extract
      stol = 0.010
      etol = 10.0
      npairmin = 6
      CALL dsteval
      IF (npair.lt.npairmin) THEN
        CALL dumb
        err = -1
        RETURN
      ENDIF
      WRITE (*,9001) np1,np2,npair
c
c...Improve Using All Of (1) and (2)
c
      np2 = nsav
      DO i=1,np2
        xp2(i) = P12SCALE*xxsav(i)
        yp2(i) = P12SCALE*yysav(i)
        mp2(i) = mmsav(i)
        oi2(i) = i
      ENDDO
      radius = 5.0D00
      niter = 0
      npold = -1
  110 CALL xform
      CALL pairfind
      CALL pairfit(xp1, xcoef,sxcoef,sigmax, err)
      IF (err.ne.0) GO TO 200
      CALL pairfit(yp1, ycoef,sycoef,sigmay, err)
      IF (err.ne.0) GO TO 200
      niter = niter+1
      IF (npair.ne.npold) THEN
        npold = npair
        IF (niter.le.5) GO TO 110
      ENDIF
c
c...But What We Really Want Is CCD -> PMM So We Must Compute The Reverse
c
      CALL pairrev(xp2, xcoef,sxcoef,sigmax, err)
      IF (err.ne.0) GO TO 200
      CALL pairrev(yp2, ycoef,sycoef,sigmay, err)
      IF (err.ne.0) GO TO 200
      WRITE (*,9003) niter,npair,sigmax,sigmay
      DO i=1,ncoef
        WRITE (*,9004) i,xcoef(i),sxcoef(i),ycoef(i),sycoef(i)
      ENDDO
      RETURN
c
c...Some Error Condition
c
  200 WRITE (*,9002) err
      RETURN
      END
