      SUBROUTINE  pairrev(zz, zcoef,szcoef,sigmaz, err)
c
c...Least Squares Fit To Reverse Plate Constants From BIG Arrays
c
      INCLUDE
     *            'sdss.inc'
      DOUBLE PRECISION
     *            zcoef(*), szcoef(*), sigmaz, x, y, z, chisq, zc,
     *            zr, m
      INTEGER
     *            i, j, k, nn, zz(*), ising, err
c
 9001 FORMAT (' Singular Matrix In PAIRREV')
c
c...Initialization
c
  100 DO i=1,ncoef
        zlhs(i) = 0.0D00
        DO j=1,ncoef
          zrhs(i,j) = 0.0D00
        ENDDO
      ENDDO
      chisq = 0.0
      sigmaz = -1.0D00
c
c...Accumulation
c
      DO i=1,npair
        x = xp1(pair1(i))/P12SCALE
        y = yp1(pair1(i))/P12SCALE
        z = zz(pair2(i))/P12SCALE
        CALL filldv(x,y)
        DO j=1,ncoef
          zlhs(j) = zlhs(j) + dv(j)*z
          DO k=1,ncoef
            zrhs(j,k) = zrhs(j,k) + dv(j)*dv(k)
          ENDDO
        ENDDO
      ENDDO
c
c...Inversion
c
      CALL matinv(ising)
      IF (ising.ne.0) THEN
        WRITE (*,9001)
        err = -11
        RETURN
      ENDIF
c
c...Coefficients
c
      DO i=1,ncoef
        zcoef(i) = 0.0D00
        DO j=1,ncoef
          zcoef(i) = zcoef(i) + zrhs(i,j)*zlhs(j)
        ENDDO
      ENDDO
c
c...Residuals And ChiSquared
c
      DO i=1,npair
        x = xp1(pair1(i))/P12SCALE
        y = yp1(pair1(i))/P12SCALE
        z = zz(pair2(i))/P12SCALE
        CALL filldv(x,y)
        zc = 0.0D00
        DO j=1,ncoef
          zc = zc + zcoef(j)*dv(j)
        ENDDO
        zr = z-zc
        chisq = chisq + zr*zr
      ENDDO
      i = MAX(1,npair-(ncoef+1))
      sigmaz = telscale*SQRT(chisq/i)
c
c...Errors
c
      DO i=1,ncoef
        szcoef(i) = sigmaz*SQRT(zrhs(i,i))
      ENDDO
      err = 0
      RETURN
      END
